"""
Program for probing the ability of LLMs to classify sentiment for poem_sentiment.
Adapted from Carloyn Anderson's CS 333: Natural Language Processing at Wellesley College.
"""
import query_llama
import pandas as pd
import random 

def get_data():
    dev = pd.read_csv('data/dev.tsv', sep='\t')
    test = pd.read_csv('data/test.tsv', sep='\t')
    return dev, test

def generate_examples(dev):
    'Add code to create in-context examples'
    raise NotImplementedError

def make_prompt(ex, examples):
    prefix = 'Give the sentiment of the following text.\n'
    post_prompt = ": "
    return prefix+examples+ex+post_prompt

def run_one_prompt(ex, examples):
    prompt = make_prompt(ex, examples)
    result = query_llama.generate(prompt)
    # Get the first word as the response
    answer = result.strip().split()[0]
    return answer

def main():
    dev, test = get_data()
    examples = ''
    scores = []
    for _, row in test.iterrows():
        text = row['text']
        label = row['class']
        pred = run_one_prompt(text, examples)
        if label == pred:
            scores.append(1)
        else:
            scores.append(0)
    print(sum(scores)/len(scores))

main()
